// подключение библиотеки SoftwareSerial
#include <SoftwareSerial.h>
// создание экземпляра SoftwareSerial
// на RX-7, TX-6 
SoftwareSerial RS485Serial(7, 6); 
// пин Arduino, к которому подключены выводы RE и DE 
// конвертирующего модуля (выбор передача/получение)
const int PIN_DIR = 10;  
// Контакт 2 для подключения кнопки
const int BTN=12;              
// предыдущее состояние кнопки
boolean prevBTN = 0;        
// текущее состояние кнопки
boolean curBTN = 0;     
// состояние светодиода 
boolean ledOn = false;     
      
void setup(){
  pinMode(PIN_DIR,OUTPUT);    
  // в режим передатчика
  digitalWrite(PIN_TX_RX, HIGH);    
  // запуск последовательного порта
  Serial.begin(9600);
  // запуск SoftwareSerial
  RS485Serial.begin(9600);
}
 
void loop() {
  curBTN = debounce(prevBTN);
  if (prevBTN == LOW && curBTN == HIGH) // при нажатии
    { 
    // изменить значение состояния светодиода 
    ledOn = !ledOn;   
    if(ledOn)
       RS485Serial.println("1=1");
    else
       RS485Serial.println("1=0");
    }
    }
  prevBTN = curBTN;  
}
// сглаживание дребезга
boolean debounce(boolean prev) {
  boolean cur = digitalRead(BTN);   
  if (prev != cur)                     
    {// ждем 5мс
    delay(5);                              
    cur = digitalRead(BTN);         
    return cur;                        
    }
}
